; Inno Setup
; Copyright (C) 1997-2004 Jordan Russell. All rights reserved.
; Portions by Martijn Laan
; For conditions of distribution and use, see LICENSE.TXT.
;
; Inno Setup QuickStart Pack Setup script by Martijn Laan
;
; $jrsoftware: ispack/setup.iss,v 1.19 2004/06/19 20:02:02 mlaan Exp $

[Setup]
AppName=Inno Setup QuickStart Pack
AppId=Inno Setup 4
AppVerName=Inno Setup QuickStart Pack 4.2.6
AppVersion=4.2.6
AppPublisher=Martijn Laan
AppPublisherURL=http://www.innosetup.com/
AppSupportURL=http://www.innosetup.com/
AppUpdatesURL=http://www.innosetup.com/
AppMutex=InnoSetupCompilerAppMutex,Global\InnoSetupCompilerAppMutex
DefaultDirName={pf}\Inno Setup 4
DefaultGroupName=Inno Setup 4
Compression=lzma/ultra
InternalCompressLevel=ultra
SolidCompression=yes
UninstallDisplayIcon={app}\Compil32.exe
LicenseFile=isfiles\license.txt
AppModifyPath="{app}\Ispack-setup.exe" /modify=1

[Messages]
AboutSetupNote=Inno Setup Preprocessor home page:%nhttp://ispp.sourceforge.net/

[Tasks]
Name: desktopicon; Description: "{cm:CreateDesktopIcon}"
;Name: fileassoc; Description: "{cm:AssocFileExtension,Inno Setup,.iss}"

[Files]
;first the files used by [Code] so these can be quickly decompressed despite solid compression
Source: "otherfiles\ISTool.ico"; Flags: dontcopy
Source: "otherfiles\ISPP.ico"; Flags: dontcopy
Source: "otherfiles\ISCrypt.ico"; Flags: dontcopy
Source: "isxdlfiles\isxdl.dll"; Flags: dontcopy
;other files
Source: "isfiles\license.txt"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\ISetup.hlp"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\ISetup.cnt"; DestDir: "{app}"; Flags: ignoreversion; AfterInstall: AddISPPCnt({app}\ISetup.cnt)
Source: "isppfiles\ISPP.hlp"; DestDir: "{app}"; Flags: promptifolder
Source: "isppfiles\ISPP.cnt"; DestDir: "{app}"; Flags: promptifolder
Source: "isfiles\Compil32.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\ISCC.exe"; DestDir: "{app}"; Flags: ignoreversion; Check: ISPPCheck(0)
Source: "isppfiles\ISPPCC.exe"; DestDir: "{app}"; DestName: "ISCC.exe"; Flags: ignoreversion; Check: ISPPCheck(1)
Source: "isfiles\ISCmplr.dll"; DestDir: "{app}"; Flags: ignoreversion; Check: ISPPCheck(0)
Source: "isppfiles\ISCmplr.dll"; DestDir: "{app}"; Flags: promptifolder; Check: ISPPCheck(1)
Source: "isfiles\ISCmplr.dll"; DestDir: "{app}"; DestName: "ISCmplr.dls"; Flags: ignoreversion; Check: ISPPCheck(1)
Source: "isppfiles\Builtins.iss"; DestDir: "{app}"; Flags: promptifolder; Check: ISPPCheck(1)
Source: "isfiles\Setup.e32"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\SetupLdr.e32"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\Uninst.e32"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\RegSvr.e32"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\Default.isl"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\Languages\Catalan.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\Czech.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\Dutch.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\French.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\German.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\Norwegian.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\Polish.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\PortugueseStd.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\Russian.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\Languages\Slovenian.isl"; DestDir: "{app}\Languages"; Flags: ignoreversion
Source: "isfiles\WizModernImage.bmp"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\WizModernImage2.bmp"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\WizModernSmallImage.bmp"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\WizModernSmallImage2.bmp"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\iszlib.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\isunzlib.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\isbzip.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\isbunzip.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\islzma.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\whatsnew.htm"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\isfaq.htm"; DestDir: "{app}"; Flags: ignoreversion
Source: "isfiles\Examples\Example1.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Example2.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Example3.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Components.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Languages.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\MyProg.exe"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\MyProg.hlp"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Readme.txt"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Readme-Dutch.txt"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\Readme-German.txt"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\CodeExample1.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\CodeDlg.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\CodeClasses.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\CodeDll.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\CodeAutomation.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\MyDll.dll"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\MyDll\C\MyDll.c"; DestDir: "{app}\Examples\MyDll\C"; Flags: ignoreversion
Source: "isfiles\Examples\MyDll\C\MyDll.def"; DestDir: "{app}\Examples\MyDll\C"; Flags: ignoreversion
Source: "isfiles\Examples\MyDll\C\MyDll.dsp"; DestDir: "{app}\Examples\MyDll\C"; Flags: ignoreversion
Source: "isfiles\Examples\MyDll\Delphi\MyDll.dpr"; DestDir: "{app}\Examples\MyDll\Delphi"; Flags: ignoreversion
Source: "isfiles\Examples\ISPPExample1.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "isfiles\Examples\ISPPExample1License.txt"; DestDir: "{app}\Examples"; Flags: ignoreversion
Source: "Setup.iss"; DestDir: "{app}\Examples"; Flags: ignoreversion
;external files
Source: "{tmp}\ISCrypt.dll"; DestDir: "{app}"; Flags: external ignoreversion; Check: ISCryptCheck(1)
Source: "{srcexe}"; DestDir: "{app}"; DestName: "Ispack-setup.exe"; Flags: external ignoreversion; Check: ModifyingCheck(0)

[InstallDelete]
;optional ISPP files
Type: files; Name: {app}\Iscmplr.dls
Type: files; Name: {app}\Builtins.iss
;optional ISCrypt files
Type: files; Name: {app}\IsCrypt.dll
;optional desktop icon files
Type: files; Name: {userdesktop}\Inno Setup Compiler.lnk

[UninstallDelete]
Type: files; Name: "{app}\Examples\Output\SETUP.EXE"
Type: files; Name: "{app}\Examples\Output\SETUP.0"
Type: files; Name: "{app}\Examples\Output\SETUP-1.BIN"
Type: files; Name: "{app}\Examples\Output\SETUP.MSG"
Type: dirifempty; Name: "{app}\Examples\Output"
Type: dirifempty; Name: "{app}\Examples\MyDll\Delphi"
Type: dirifempty; Name: "{app}\Examples\MyDll\C"
Type: dirifempty; Name: "{app}\Examples\MyDll"
Type: dirifempty; Name: "{app}\Examples"

[Icons]
Name: "{group}\Inno Setup Compiler"; Filename: "{app}\Compil32.exe"; WorkingDir: "{app}"
Name: "{group}\Inno Setup Documentation"; Filename: "{app}\ISetup.hlp";
Name: "{group}\Inno Setup Preprocessor Documentation"; Filename: "{app}\ISPP.hlp";
Name: "{group}\Inno Setup FAQ"; Filename: "{app}\isfaq.htm";
Name: "{group}\Inno Setup Revision History"; Filename: "{app}\whatsnew.htm";
Name: "{userdesktop}\Inno Setup Compiler"; Filename: "{app}\Compil32.exe"; WorkingDir: "{app}"; Tasks: desktopicon; Check: ISToolCheck(0)

[Registry]
Root: HKCU; Subkey: "Software\Jordan Russell"; Flags: uninsdeletekeyifempty
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup"; Flags: uninsdeletekey
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History0"; ValueData: "{app}\Examples\Example1.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History1"; ValueData: "{app}\Examples\Example2.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History2"; ValueData: "{app}\Examples\Example3.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History3"; ValueData: "{app}\Examples\CodeExample1.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History4"; ValueData: "{app}\Examples\CodeDlg.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History5"; ValueData: "{app}\Examples\CodeClasses.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History6"; ValueData: "{app}\Examples\CodeDll.iss"; Flags: createvalueifdoesntexist
Root: HKCU; Subkey: "Software\Jordan Russell\Inno Setup\ScriptFileHistoryNew"; ValueType: string; ValueName: "History7"; ValueData: "{app}\Examples\ISPPExample1.iss"; Flags: createvalueifdoesntexist
Root: HKCU; SubKey: "Software\Bjornar Henden\ISTool4\Prefs"; ValueType: string; ValueName: "InnoFolder"; ValueData: "{app}"; Flags: createvalueifdoesntexist

[Run]
Filename: "{tmp}\istool-setup.exe"; StatusMsg: "Installing ISTool..."; Parameters: "/verysilent /group=""{groupname}\ISTool"" desktopicon"; Flags: skipifdoesntexist; Check: ISToolCheck(1); Tasks: desktopicon
Filename: "{tmp}\istool-setup.exe"; StatusMsg: "Installing ISTool..."; Parameters: "/verysilent /group=""{groupname}\ISTool"""; Flags: skipifdoesntexist; Check: ISToolCheckAndNoDesktopIcon
Filename: "{app}\Compil32.exe"; Parameters: "/ASSOC"; StatusMsg: "{cm:AssocingFileExtension,Inno Setup,.iss}"; Check: ISToolCheck(0)
Filename: "{app}\Compil32.exe"; WorkingDir: "{app}"; Description: "{cm:LaunchProgram,Inno Setup}"; Flags: nowait postinstall skipifsilent; Check: ISToolCheckAndNotModifying(0)
Filename: "{code:GetISToolPath}\ISTool.exe"; WorkingDir: "{code:GetISToolPath}"; Description: "{cm:LaunchProgram,ISTool}"; Flags: nowait postinstall skipifsilent skipifdoesntexist; Check: ISToolCheckAndNotModifying(1)

[UninstallRun]
Filename: "{app}\Compil32.exe"; Parameters: "/UNASSOC"; RunOnceId: "RemoveISSAssoc"
Filename: "rundll32.exe"; Parameters: """{app}\ISCmplr.dll"",ISPPDllUninstall"; Flags: skipifdoesntexist

[Code]
var
  Modifying: Boolean;

  ISTool, ISToolOrg: Boolean;
  ISPP: Boolean;
  ISCrypt: Boolean;

  FilesDownloaded: Boolean;
  
  ISToolPath: String;
  ISToolPathRead: Boolean;

procedure isxdl_AddFile(URL, Filename: PChar);
external 'isxdl_AddFile@files:isxdl.dll stdcall';
function isxdl_DownloadFiles(hWnd: Integer): Integer;
external 'isxdl_DownloadFiles@files:isxdl.dll stdcall';
function isxdl_SetOption(Option, Value: PChar): Integer;
external 'isxdl_SetOption@files:isxdl.dll stdcall';

function GetModuleHandle(lpModuleName: LongInt): LongInt;
external 'GetModuleHandleA@kernel32.dll stdcall';
function ExtractIcon(hInst: LongInt; lpszExeFileName: PChar; nIconIndex: LongInt): LongInt;
external 'ExtractIconA@shell32.dll stdcall';
function DrawIconEx(hdc: LongInt; xLeft, yTop: Integer; hIcon: LongInt; cxWidth, cyWidth: Integer; istepIfAniCur: LongInt; hbrFlickerFreeDraw, diFlags: LongInt): LongInt;
external 'DrawIconEx@user32.dll stdcall';
function DestroyIcon(hIcon: LongInt): LongInt;
external 'DestroyIcon@user32.dll stdcall';

const
  DI_NORMAL = 3;

function InitializeSetup(): Boolean;
begin
  Modifying := ExpandConstant('{param:modify|0}') = '1';

  ISTool := GetPreviousData('ISTool', '1') = '1';
  ISToolOrg := ISTool;
  ISPP := GetPreviousData('ISPP', '1') = '1';
  ISCrypt := GetPreviousData('ISCrypt', '1') = '1';

  FilesDownloaded := False;
  
  ISToolPathRead := False;
    
  Result := True;
end;

procedure RegisterPreviousData(PreviousDataKey: Integer);
begin
  if ISTool then
    SetPreviousData(PreviousDataKey, 'ISTool', '1')
  else
    SetPreviousData(PreviousDataKey, 'ISTool', '0');

  if ISPP then
    SetPreviousData(PreviousDataKey, 'ISPP', '1')
  else
    SetPreviousData(PreviousDataKey, 'ISPP', '0');

  if ISCrypt then
    SetPreviousData(PreviousDataKey, 'ISCrypt', '1')
  else
    SetPreviousData(PreviousDataKey, 'ISCrypt', '0');
end;

procedure FDoCustomOptionPage(ACaption, ASubCaption1, AIconFileName, ALabel1Caption, ALabel2Caption,
  ACheckCaption: String; var ANext, AChecked: Boolean);
var
  Rect: TRect;
  hIcon: LongInt;
  Label1, Label2: TNewStaticText;
  Check: TCheckBox;
begin
  AIconFileName := ExpandConstant('{tmp}\' + AIconFileName);
  if not FileExists(AIconFileName) then
    ExtractTemporaryFile(ExtractFileName(AIconFileName));

  ScriptDlgPageSetCaption(ACaption);
  ScriptDlgPageSetSubCaption1(ASubCaption1);

  ScriptDlgPageClearCustom();

  Rect.Left := 0;
  Rect.Top := 0;
  Rect.Right := 32;
  Rect.Bottom := 32;

  hIcon := ExtractIcon(GetModuleHandle(0), AIconFileName, 0);
  try
    with TBitmapImage.Create(WizardForm.ScriptDlgPanel) do begin
      with Bitmap do begin
        Width := 32;
        Height := 32;
        Canvas.Brush.Color := WizardForm.ScriptDlgPanel.Color;
        Canvas.FillRect(Rect);
        DrawIconEx(Canvas.Handle, 0, 0, hIcon, 32, 32, 0, 0, DI_NORMAL);
      end;
      Parent := WizardForm.ScriptDlgPanel;
    end;
  finally
    DestroyIcon(hIcon);
  end;

  Label1 := TNewStaticText.Create(WizardForm.ScriptDlgPanel);
  with Label1 do begin
    AutoSize := False;
    Left := WizardForm.SelectDirLabel.Left - WizardForm.ScriptDlgPanel.Left;
    Width := WizardForm.ScriptDlgPanel.Width - Left;
    WordWrap := True;
    Caption := ALabel1Caption;
    Parent := WizardForm.ScriptDlgPanel;
  end;
  WizardForm.AdjustLabelHeight(Label1);

  Label2 := TNewStaticText.Create(WizardForm.ScriptDlgPanel);
  with Label2 do begin
    Top := Label1.Top + Label1.Height + 12;
    Caption := ALabel2Caption;
    Parent := WizardForm.ScriptDlgPanel;
  end;
  WizardForm.AdjustLabelHeight(Label2);

  Check := TCheckBox.Create(WizardForm.ScriptDlgPanel);
  with Check do begin
    Top := Label2.Top + Label2.Height + 12;
    Width := WizardForm.ScriptDlgPanel.Width;
    Caption := ACheckCaption;
    Checked := AChecked;
    Parent := WizardForm.ScriptDlgPanel;
  end;

  ANext := ScriptDlgPageProcessCustom(Check);
  AChecked := Check.Checked;
end;

function FDoCustomPages(BackClicked: Boolean): Boolean;
var
  CurSubPage: Integer;
  Next: Boolean;
  Caption, SubCaption1, IconFileName, Label1Caption, Label2Caption, CheckCaption: String;
begin
  if not BackClicked then
    CurSubPage := 0
  else
    CurSubPage := 2;
  Next := not BackClicked;

  ScriptDlgPageOpen();
  while (CurSubPage >= 0) and (CurSubPage <= 2) and not Terminated do begin
    case CurSubPage of
      0:
        begin
          if not (Modifying and ISToolOrg) then begin
            Caption := 'ISTool';
            SubCaption1 := 'Would you like to download and install ISTool?';
            IconFileName := 'ISTool.ico';
            Label1Caption :=
              'ISTool is an easy to use Inno Setup Script editor by Bjrnar Henden and meant as a replacement of the standard' +
              ' Compiler IDE that comes with Inno Setup. See http://www.istool.org/ for more information.' + #13#10#13#10 +
              'Using ISTool is especially recommended for new users.';
            Label2Caption := 'Select whether you would like to download and install ISTool, then click Next.';
            CheckCaption := '&Download and install ISTool';

            FDoCustomOptionPage(Caption, SubCaption1, IconFileName, Label1Caption, Label2Caption, CheckCaption, Next, ISTool);
          end;
        end;
      1:
        begin
          Caption := 'Inno Setup Preprocessor';
          SubCaption1 := 'Would you like to install Inno Setup Preprocessor?';
          IconFileName := 'ISPP.ico';
          Label1Caption :=
            'Inno Setup Preprocessor (ISPP) is an add-on by Alex Yackimoff for Inno Setup. ISPP allows' +
            ' you to conditionally compile parts of scripts, to use compile time variables in your scripts and to use built-in' +
            ' functions which for example can read from the registry or INI files at compile time. See http://ispp.sf.net for more' +
            ' information.' + #13#10#13#10 +
            'ISPP also contains a special version of the ISCC command line compiler which can take variable definitions as command' +
            ' line parameters and use them during compilation.' + #13#10#13#10 +
            'ISPP is compatible with ISTool.';
          Label2Caption := 'Select whether you would like to install ISPP, then click Next.';
          CheckCaption := '&Install Inno Setup Preprocessor';

          FDoCustomOptionPage(Caption, SubCaption1, IconFileName, Label1Caption, Label2Caption, CheckCaption, Next, ISPP);
        end;
      2:
        begin
          Caption := 'Encryption Support';
          SubCaption1 := 'Would you like to download encryption support?';
          IconFileName := 'ISCrypt.ico';
          Label1Caption :=
            'Because of encryption import/export laws in some countries, encryption support is not included in the main' +
            ' Inno Setup installer. Instead, it can be downloaded from a server located in the Netherlands now.';
          Label2Caption := 'Select whether you would like to download encryption support, then click Next.';
          CheckCaption := '&Download and install encryption support';

          FDoCustomOptionPage(Caption, SubCaption1, IconFileName, Label1Caption, Label2Caption, CheckCaption, Next, ISCrypt);
        end;
    end;
    if Next then
      CurSubPage := CurSubPage + 1
    else
      CurSubPage := CurSubPage - 1;
  end;
  if not BackClicked then
    Result := Next
  else
    Result := not Next;
  ScriptDlgPageClose(not Result);
end;

function FDoFilesDownload(ISTool, ISCrypt: Boolean): Boolean;
var
  hWnd: Integer;
  URL, FileName: String;
begin
  isxdl_SetOption('label', 'Downloading extra files');
  isxdl_SetOption('description', 'Please wait while Setup is downloading extra files to your computer.');

  //turn off isxdl resume so it won't leave partially downloaded files behind
  //resuming wouldn't help anyway since we're going to download to {tmp}
  isxdl_SetOption('resume', 'false');

  hWnd := StrToInt(ExpandConstant('{wizardhwnd}'));
  
  if ISTool then begin
    URL := 'http://www.istool.org/getistool.aspx';
    FileName := ExpandConstant('{tmp}\istool-setup.exe');
    isxdl_AddFile(URL, FileName);
  end;
  
  if ISCrypt then begin
    URL := 'http://www.xs4all.nl/~mlaan2/iscrypt/ISCrypt.dll';
    FileName := ExpandConstant('{tmp}\ISCrypt.dll');
    isxdl_AddFile(URL, FileName);
  end;

  if isxdl_DownloadFiles(hWnd) <> 0 then
    FilesDownloaded := True
  else
    MsgBox('Setup could not download the extra files. Try again later or download and install the extra files manually.' + #13#13 + 'Setup will now continue installing normally.', mbError, mb_Ok);

  Result := True;
end;

function FScriptDlgPages(CurPage: Integer; BackClicked: Boolean): Boolean;
begin
  if (not BackClicked and not Modifying and (CurPage = wpSelectProgramGroup)) or
     (not BackClicked and Modifying and (CurPage = wpLicense)) or
     (BackClicked and (CurPage = wpSelectTasks)) then
    Result := FDoCustomPages(BackClicked)
  else if not BackClicked and (CurPage = wpReady) and (ISTool or ISCrypt) then
    Result := FDoFilesDownload(ISTool, ISCrypt)
  else
    Result := True;
end;

function NextButtonClick(CurPage: Integer): Boolean;
begin
  Result := FScriptDlgPages(CurPage, False);
end;

function BackButtonClick(CurPage: Integer): Boolean;
begin
  Result := FScriptDlgPages(CurPage, True);
end;

function SkipCurPage(CurPage: Integer): Boolean;
begin
  Result := Modifying and ((CurPage = wpSelectDir) or (CurPage = wpSelectProgramGroup));
end;

function ModifyingCheck(RequiredModifying: String): Boolean;
begin
  Result := Modifying = (RequiredModifying = '1');
end;

function ISToolCheck(RequiredISTool: String): Boolean;
begin
  Result := (ISTool and FilesDownloaded) = (RequiredISTool = '1');
end;

function ISToolCheckAndNoDesktopIcon(): Boolean;
begin
  Result := ISToolCheck('1') and (ShouldProcessEntry('', 'desktopicon') <> srYes);
end;

function ISToolCheckAndNotModifying(RequiredISTool: String): Boolean;
begin
  Result := IsToolCheck(RequiredISTool) and not Modifying;
end;

function ISPPCheck(RequiredISPP: String): Boolean;
begin
  Result := ISPP = (RequiredISPP = '1');
end;

function ISCryptCheck(RequiredISCrypt: String): Boolean;
begin
  Result := (ISCrypt and FilesDownloaded) = (RequiredISCrypt = '1');
end;

function GetISToolPath(S: String): String;
var
  ISToolPathKeyName, ISToolPathValueName: String;
begin
  if not ISToolPathRead then begin
    ISToolPathKeyName := 'Software\Microsoft\Windows\CurrentVersion\Uninstall\{A9E12684-DD23-4D11-ACAF-6041954BCA00}_is1';
    ISToolPathValueName := 'Inno Setup: App Path';

    if not RegQueryStringValue(HKLM, ISToolPathKeyName, ISToolPathValueName, ISToolPath) then begin
      if not RegQueryStringValue(HKCU, ISToolPathKeyName, ISToolPathValueName, ISToolPath) then begin
        MsgBox('Error launching ISTool:'#13'Could not read ISTool path from registry.', mbError, mb_Ok);
        ISToolPath := '';
      end;
    end;

    ISToolPathRead := True;
  end;

  Result := ISToolPath;
end;

procedure AddISPPCnt(FileName: String);
var
  SL: TStringList;
begin
  if ISPPCheck('1') then begin
    SL := TStringList.Create();
    try
      SL.LoadFromFile(FileName);
      SL.Append(':Include ispp.cnt');
      SL.Append(':Index Inno Setup Preprocessor Reference=ispp.hlp');
      SL.Append('');
      SL.SaveToFile(FileName);
    finally
      SL.Free();
    end;
  end;
end;

