; Rockbox Installer Build Script for InnoSetup 4
;
; Copyright Christi Alice Scarborough
; Version 1.0.1 - 29th Jun 2004
;
; Released under the GPL - see file COPYING for details

; These may need to be over-ridden - Release, BuildRootDir and
; AppVersion may be passed in from an external script.

; Include
#ifexist "..\files\rockbox.version.iss"
#include "..\files\rockbox.version.iss"
#endif

;#define Release ; If this is a release version of Rockbox
#define AppName "Rockbox" 
;#ifndef AppVersion
;#define AppVersion "20040627" ; should fail if it's not in the include
;#endif
#ifndef BuildRootDir
#define BuildRootDir "R:\"
#endif

; Other #defines - shouldn't need changing.
#ifdef Release
#define AppDesc "version"
#define DownloadLoc "download/"
#else
#define AppDesc "daily build"
#define DownloadLoc "daily.shtml"
#endif
; Location of package files relative to SrcDir
#define FileDir "..\files"

[Setup]
InternalCompressLevel=ultra
OutputDir={#BuildRootDir}
SourceDir={#BuildRootDir}\src
SolidCompression=true
VersionInfoCompany=The {#AppName} Crew
VersionInfoDescription={#AppName} open source Archos Jukebox firmware
Compression=lzma/ultra
AppName={#AppName}
RestartIfNeededByRun=false
DefaultDirName=E:\
AllowRootDirectory=true
DirExistsWarning=no
AppendDefaultDirName=false
DisableProgramGroupPage=true
ShowLanguageDialog=yes
;SetupIconFile={#BuildRootDir}\src\archos.ico ; not when compiling under Wine
Uninstallable=true
AppID={{DDE16033-445F-4BCD-9B0F-C3F0C1863344}}
VersionInfoTextVersion={#AppVersion}
AppVerName={#AppName} {#AppDesc} {#AppVersion}
OutputBaseFilename={#AppName}-{#AppVersion}-install
UninstallLogMode=append
AppSupportURL=http://rockbox.haxx.se/
AppUpdatesURL=http://rockbox.haxx.se/{#DownloadLoc}
UninstallFilesDir={userappdata}\RockboxInst
UninstallDisplayIcon={userappdata}\RockboxInst\archos.ico
[Types]
Name: player; Description: Jukebox Studio 6000, Studio 20
Name: recorderv1; Description: Jukebox Recorder 6, 10, 20
Name: recorderv2; Description: Jukebox recorder version 2
Name: recorderfm; Description: Jukebox Recorder FM
[Components]
Name: common; Description: Platform independent files; Flags: fixed; Types: recorderfm recorderv2 recorderv1 player
Name: player; Description: Files and firmware for the Jukebox Player; Flags: fixed; Types: player
Name: recorder; Description: Files common to all Jukebox Recorders; Flags: fixed; Types: recorderfm recorderv2 recorderv1
Name: recorderv1; Description: Recorder v1 firmware; Flags: fixed; Types: recorderv1
Name: recorderv2; Description: Recorder v2 firmware; Flags: fixed; Types: recorderv2
Name: recorderfm; Description: Recorder FM firmware; Flags: fixed; Types: recorderfm
[Files]
Source: {#FileDir}\common\.rockbox\docs\*; DestDir: {app}\.rockbox\docs\; Flags: ignoreversion replacesameversion
Source: {#FileDir}\common\.rockbox\langs\*; DestDir: {app}\.rockbox\langs\; Flags: ignoreversion replacesameversion
Source: {#FileDir}\player\*; DestDir: {app}; Flags: ignoreversion replacesameversion; Components: player
Source: {#FileDir}\player\.rockbox\rocks\*; DestDir: {app}\.rockbox\rocks\; Flags: ignoreversion replacesameversion; Components: player
Source: {#FileDir}\recorder-common\.rockbox\*; DestDir: {app}\.rockbox\; Flags: ignoreversion replacesameversion; Components: recorder
Source: {#FileDir}\recorder-common\.rockbox\rocks\*; DestDir: {app}\.rockbox\rocks; Flags: ignoreversion replacesameversion; Components: recorder
Source: {#FileDir}\recorder-common\.rockbox\fonts\*; DestDir: {app}\.rockbox\fonts\; Flags: ignoreversion replacesameversion; Components: recorder
Source: {#FileDir}\recorder-common\.rockbox\viewers\*; DestDir: {app}\.rockbox\viewers\; Flags: ignoreversion replacesameversion; Components: recorder
Source: {#FileDir}\rv1\.rockbox\rocks\*; DestDir: {app}\.rockbox\rocks; Flags: ignoreversion replacesameversion; Components: recorderv1
Source: {#FileDir}\rv1\.rockbox\viewers\*; DestDir: {app}\.rockbox\viewers; Flags: ignoreversion replacesameversion; Components: recorderv1
Source: {#FileDir}\rv1\ajbrec.ajz; DestDir: {app}; Flags: ignoreversion replacesameversion; Components: recorderv1
Source: {#FileDir}\rv1\rockbox.ucl; DestDir: {app}\.rockbox\; Flags: ignoreversion replacesameversion; Components: recorderv1
Source: {#FileDir}\rv2\.rockbox\rocks\*; DestDir: {app}\.rockbox\rocks; Flags: ignoreversion replacesameversion; Components: recorderv2
Source: {#FileDir}\rv2\.rockbox\viewers\*; DestDir: {app}\.rockbox\viewers; Flags: ignoreversion replacesameversion; Components: recorderv2
Source: {#FileDir}\rv2\ajbrec.ajz; DestDir: {app}; Flags: ignoreversion replacesameversion; Components: recorderv2
Source: {#FileDir}\rv2\rockbox.ucl; DestDir: {app}\.rockbox\; Flags: ignoreversion replacesameversion; Components: recorderv2
Source: {#FileDir}\rfm\.rockbox\rocks\*; DestDir: {app}\.rockbox\rocks; Flags: ignoreversion replacesameversion; Components: recorderfm
Source: {#FileDir}\rfm\.rockbox\viewers\*; DestDir: {app}\.rockbox\viewers; Flags: ignoreversion replacesameversion; Components: recorderfm
Source: {#FileDir}\rfm\ajbrec.ajz; DestDir: {app}; Flags: ignoreversion replacesameversion; Components: recorderfm
Source: {#FileDir}\rfm\rockbox.ucl; DestDir: {app}\.rockbox; Flags: ignoreversion replacesameversion; Components: recorderfm
Source: archos.ico; DestDir: {userappdata}\RockboxInst; Flags: ignoreversion replacesameversion
[Messages]
BrowseDialogLabel=Select the drive letter of your Jukebox below (e.g. E:\) then click OK.
WelcomeLabel2=This will install [name/ver] on your computer.%n%nPlease ensure that your Jukebox is plugged into the USB port of your computer and is turned on before continuing.%n%nIt is recommended that you close all other applications before continuing.
SelectDirLabel3=Please select the drive letter for your Jukebox (eg E:\) below:
SelectStartMenuFolderBrowseLabel=To continue, click Next.  If you would like to select a different drive, click Browse.
SelectComponentsLabel2=Please select your Archos Jukebox model from the list below.
ConfirmUninstall=Please connect your Jukebox to a USB port on your computer and then turn it on before continuing.%n%nAre you sure you want to completely remove %1 and all of its components?
[Code]
function NextButtonClick(curpage: Integer): Boolean;

begin
   Result := True;
   case curpage of
   wpSelectDir:
      if CompareText(WizardDirValue, AddBackSlash(ExtractFileDrive(WizardDirValue))) <> 0 then
      begin
         MsgBox('You must select the root directory of your Archos drive (e.g. E:\)', mbError, MB_OK);
         Result := False;
      end;
    end;
end;
